---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Converter board registers
---------------------------------------------------------------------------------------
-- File           : conv_regs.vhd
-- Author         : auto-generated by wbgen2 from .\conv_regs.wb
-- Created        : 09/26/17 10:50:26
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE .\conv_regs.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity conv_regs is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(5 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
-- Port for std_logic_vector field: 'ID register bits' in reg: 'BIDR'
    reg_bidr_i                               : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Gateware version' in reg: 'SR'
    reg_sr_gwvers_i                          : in     std_logic_vector(7 downto 0);
-- Port for std_logic_vector field: 'Status of on-board general-purpose switches' in reg: 'SR'
    reg_sr_switches_i                        : in     std_logic_vector(7 downto 0);
-- Port for std_logic_vector field: 'RTM detection lines cite{rtm-det}' in reg: 'SR'
    reg_sr_rtm_i                             : in     std_logic_vector(5 downto 0);
-- Port for std_logic_vector field: 'Hardware version' in reg: 'SR'
    reg_sr_hwvers_i                          : in     std_logic_vector(5 downto 0);
-- Port for BIT field: 'White Rabbit present' in reg: 'SR'
    reg_sr_wrpres_i                          : in     std_logic;
-- Ports for BIT field: 'I2C communication watchdog timeout error' in reg: 'ERR'
    reg_err_i2c_wdto_o                       : out    std_logic;
    reg_err_i2c_wdto_i                       : in     std_logic;
    reg_err_i2c_wdto_load_o                  : out    std_logic;
-- Ports for BIT field: 'I2C communication error' in reg: 'ERR'
    reg_err_i2c_err_o                        : out    std_logic;
    reg_err_i2c_err_i                        : in     std_logic;
    reg_err_i2c_err_load_o                   : out    std_logic;
-- Port for std_logic_vector field: 'Frequency error' in reg: 'ERR'
    reg_err_flim_pmisse_o                    : out    std_logic_vector(5 downto 0);
    reg_err_flim_pmisse_i                    : in     std_logic_vector(5 downto 0);
    reg_err_flim_pmisse_load_o               : out    std_logic;
-- Port for std_logic_vector field: 'Frequency watchdog error' in reg: 'ERR'
    reg_err_fwdg_pmisse_o                    : out    std_logic_vector(5 downto 0);
    reg_err_fwdg_pmisse_i                    : in     std_logic_vector(5 downto 0);
    reg_err_fwdg_pmisse_load_o               : out    std_logic;
-- Ports for BIT field: 'Reset unlock bit' in reg: 'CR'
    reg_cr_rst_unlock_o                      : out    std_logic;
    reg_cr_rst_unlock_i                      : in     std_logic;
    reg_cr_rst_unlock_load_o                 : out    std_logic;
-- Ports for BIT field: 'Reset bit - active only if RST_UNLOCK is 1' in reg: 'CR'
    reg_cr_rst_o                             : out    std_logic;
    reg_cr_rst_i                             : in     std_logic;
    reg_cr_rst_load_o                        : out    std_logic;
-- Ports for PASS_THROUGH field: 'Manual Pulse Trigger' in reg: 'CR'
    reg_cr_mpt_o                             : out    std_logic_vector(7 downto 0);
    reg_cr_mpt_wr_o                          : out    std_logic;
-- Port for std_logic_vector field: 'Value of front panel pulse counter' in reg: 'CH1FPPCR'
    reg_ch1fppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch1fppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch1fppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Value of front panel pulse counter' in reg: 'CH2FPPCR'
    reg_ch2fppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch2fppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch2fppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Value of front panel pulse counter' in reg: 'CH3FPPCR'
    reg_ch3fppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch3fppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch3fppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Value of front panel pulse counter' in reg: 'CH4FPPCR'
    reg_ch4fppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch4fppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch4fppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Value of front panel pulse counter' in reg: 'CH5FPPCR'
    reg_ch5fppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch5fppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch5fppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Value of front panel pulse counter' in reg: 'CH6FPPCR'
    reg_ch6fppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch6fppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch6fppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Rear panel pulse counter value' in reg: 'CH1RPPCR'
    reg_ch1rppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch1rppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch1rppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Rear panel pulse counter value' in reg: 'CH2RPPCR'
    reg_ch2rppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch2rppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch2rppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Rear panel pulse counter value' in reg: 'CH3RPPCR'
    reg_ch3rppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch3rppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch3rppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Rear panel pulse counter value' in reg: 'CH4RPPCR'
    reg_ch4rppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch4rppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch4rppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Rear panel pulse counter value' in reg: 'CH5RPPCR'
    reg_ch5rppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch5rppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch5rppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'Rear panel pulse counter value' in reg: 'CH6RPPCR'
    reg_ch6rppcr_o                           : out    std_logic_vector(31 downto 0);
    reg_ch6rppcr_i                           : in     std_logic_vector(31 downto 0);
    reg_ch6rppcr_load_o                      : out    std_logic;
-- Port for std_logic_vector field: 'TAI seconds counter bits 31..0' in reg: 'TVLR'
    reg_tvlr_o                               : out    std_logic_vector(31 downto 0);
    reg_tvlr_i                               : in     std_logic_vector(31 downto 0);
    reg_tvlr_load_o                          : out    std_logic;
-- Port for std_logic_vector field: 'TAI seconds counter bits 39..32' in reg: 'TVHR'
    reg_tvhr_o                               : out    std_logic_vector(7 downto 0);
    reg_tvhr_i                               : in     std_logic_vector(7 downto 0);
    reg_tvhr_load_o                          : out    std_logic;
-- Port for std_logic_vector field: 'Channel mask' in reg: 'TBMR'
    reg_tbmr_chan_i                          : in     std_logic_vector(5 downto 0);
    reg_tb_rd_req_p_o                        : out    std_logic;
-- Port for BIT field: 'White Rabbit present' in reg: 'TBMR'
    reg_tbmr_wrtag_i                         : in     std_logic;
-- Port for std_logic_vector field: 'Cycles counter' in reg: 'TBCYR'
    reg_tbcyr_i                              : in     std_logic_vector(27 downto 0);
-- Port for std_logic_vector field: 'Lower part of TAI seconds counter' in reg: 'TBTLR'
    reg_tbtlr_i                              : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Upper part of TAI seconds counter' in reg: 'TBTHR'
    reg_tbthr_i                              : in     std_logic_vector(7 downto 0);
-- Port for std_logic_vector field: 'Buffer counter' in reg: 'TBCSR'
    reg_tbcsr_usedw_i                        : in     std_logic_vector(6 downto 0);
-- Port for BIT field: 'Buffer full' in reg: 'TBCSR'
    reg_tbcsr_full_i                         : in     std_logic;
-- Port for BIT field: 'Buffer empty' in reg: 'TBCSR'
    reg_tbcsr_empty_i                        : in     std_logic;
-- Ports for BIT field: 'Clear tag buffer' in reg: 'TBCSR'
    reg_tbcsr_clr_o                          : out    std_logic;
    reg_tbcsr_clr_i                          : in     std_logic;
    reg_tbcsr_clr_load_o                     : out    std_logic;
-- Port for std_logic_vector field: 'Cycles counter' in reg: 'CH1LTSCYR'
    reg_ch1ltscyr_i                          : in     std_logic_vector(27 downto 0);
-- Port for std_logic_vector field: 'Lower part of TAI seconds counter' in reg: 'CH1LTSTLR'
    reg_ch1ltstlr_i                          : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Upper part of TAI seconds counter' in reg: 'CH1LTSTHR'
    reg_ch1ltsthr_tai_i                      : in     std_logic_vector(7 downto 0);
-- Port for BIT field: 'White Rabbit present' in reg: 'CH1LTSTHR'
    reg_ch1ltsthr_wrtag_i                    : in     std_logic;
-- Port for std_logic_vector field: 'Cycles counter' in reg: 'CH2LTSCYR'
    reg_ch2ltscyr_i                          : in     std_logic_vector(27 downto 0);
-- Port for std_logic_vector field: 'Lower part of TAI seconds counter' in reg: 'CH2LTSTLR'
    reg_ch2ltstlr_i                          : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Upper part of TAI seconds counter' in reg: 'CH2LTSTHR'
    reg_ch2ltsthr_tai_i                      : in     std_logic_vector(7 downto 0);
-- Port for BIT field: 'White Rabbit present' in reg: 'CH2LTSTHR'
    reg_ch2ltsthr_wrtag_i                    : in     std_logic;
-- Port for std_logic_vector field: 'Cycles counter' in reg: 'CH3LTSCYR'
    reg_ch3ltscyr_i                          : in     std_logic_vector(27 downto 0);
-- Port for std_logic_vector field: 'Lower part of TAI seconds counter' in reg: 'CH3LTSTLR'
    reg_ch3ltstlr_i                          : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Upper part of TAI seconds counter' in reg: 'CH3LTSTHR'
    reg_ch3ltsthr_tai_i                      : in     std_logic_vector(7 downto 0);
-- Port for BIT field: 'White Rabbit present' in reg: 'CH3LTSTHR'
    reg_ch3ltsthr_wrtag_i                    : in     std_logic;
-- Port for std_logic_vector field: 'Cycles counter' in reg: 'CH4LTSCYR'
    reg_ch4ltscyr_i                          : in     std_logic_vector(27 downto 0);
-- Port for std_logic_vector field: 'Lower part of TAI seconds counter' in reg: 'CH4LTSTLR'
    reg_ch4ltstlr_i                          : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Upper part of TAI seconds counter' in reg: 'CH4LTSTHR'
    reg_ch4ltsthr_tai_i                      : in     std_logic_vector(7 downto 0);
-- Port for BIT field: 'White Rabbit present' in reg: 'CH4LTSTHR'
    reg_ch4ltsthr_wrtag_i                    : in     std_logic;
-- Port for std_logic_vector field: 'Cycles counter' in reg: 'CH5LTSCYR'
    reg_ch5ltscyr_i                          : in     std_logic_vector(27 downto 0);
-- Port for std_logic_vector field: 'Lower part of TAI seconds counter' in reg: 'CH5LTSTLR'
    reg_ch5ltstlr_i                          : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Upper part of TAI seconds counter' in reg: 'CH5LTSTHR'
    reg_ch5ltsthr_tai_i                      : in     std_logic_vector(7 downto 0);
-- Port for BIT field: 'White Rabbit present' in reg: 'CH5LTSTHR'
    reg_ch5ltsthr_wrtag_i                    : in     std_logic;
-- Port for std_logic_vector field: 'Cycles counter' in reg: 'CH6LTSCYR'
    reg_ch6ltscyr_i                          : in     std_logic_vector(27 downto 0);
-- Port for std_logic_vector field: 'Lower part of TAI seconds counter' in reg: 'CH6LTSTLR'
    reg_ch6ltstlr_i                          : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Upper part of TAI seconds counter' in reg: 'CH6LTSTHR'
    reg_ch6ltsthr_tai_i                      : in     std_logic_vector(7 downto 0);
-- Port for BIT field: 'White Rabbit present' in reg: 'CH6LTSTHR'
    reg_ch6ltsthr_wrtag_i                    : in     std_logic;
-- Port for std_logic_vector field: 'Front panel channel input state' in reg: 'LSR'
    reg_lsr_front_i                          : in     std_logic_vector(5 downto 0);
-- Port for std_logic_vector field: 'Front panel INV-TTL input state' in reg: 'LSR'
    reg_lsr_frontinv_i                       : in     std_logic_vector(3 downto 0);
-- Port for std_logic_vector field: 'Rear panel input state' in reg: 'LSR'
    reg_lsr_rear_i                           : in     std_logic_vector(5 downto 0);
-- Port for std_logic_vector field: 'Front panel input failsafe state' in reg: 'LSR'
    reg_lsr_frontfs_i                        : in     std_logic_vector(5 downto 0);
-- Port for std_logic_vector field: 'Front panel inverter input failsafe state' in reg: 'LSR'
    reg_lsr_frontinvfs_i                     : in     std_logic_vector(3 downto 0);
-- Port for std_logic_vector field: 'Rear panel input failsafe state' in reg: 'LSR'
    reg_lsr_rearfs_i                         : in     std_logic_vector(5 downto 0);
-- Port for std_logic_vector field: 'Switch state' in reg: 'OSWR'
    reg_oswr_switches_i                      : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'LS bits of 1-wire DS18B20U thermometer ID' in reg: 'UIDLR'
    reg_uidlr_i                              : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'MS bits of 1-wire DS18B20U thermometer ID' in reg: 'UIDHR'
    reg_uidhr_i                              : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'TEMP' in reg: 'TEMPR'
    reg_tempr_i                              : in     std_logic_vector(15 downto 0)
  );
end conv_regs;

architecture syn of conv_regs is

signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(5 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      reg_err_i2c_wdto_load_o <= '0';
      reg_err_i2c_err_load_o <= '0';
      reg_err_flim_pmisse_load_o <= '0';
      reg_err_fwdg_pmisse_load_o <= '0';
      reg_cr_rst_unlock_load_o <= '0';
      reg_cr_rst_load_o <= '0';
      reg_cr_mpt_wr_o <= '0';
      reg_ch1fppcr_load_o <= '0';
      reg_ch2fppcr_load_o <= '0';
      reg_ch3fppcr_load_o <= '0';
      reg_ch4fppcr_load_o <= '0';
      reg_ch5fppcr_load_o <= '0';
      reg_ch6fppcr_load_o <= '0';
      reg_ch1rppcr_load_o <= '0';
      reg_ch2rppcr_load_o <= '0';
      reg_ch3rppcr_load_o <= '0';
      reg_ch4rppcr_load_o <= '0';
      reg_ch5rppcr_load_o <= '0';
      reg_ch6rppcr_load_o <= '0';
      reg_tvlr_load_o <= '0';
      reg_tvhr_load_o <= '0';
      reg_tb_rd_req_p_o <= '0';
      reg_tbcsr_clr_load_o <= '0';
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          reg_err_i2c_wdto_load_o <= '0';
          reg_err_i2c_err_load_o <= '0';
          reg_err_flim_pmisse_load_o <= '0';
          reg_err_fwdg_pmisse_load_o <= '0';
          reg_cr_rst_unlock_load_o <= '0';
          reg_cr_rst_load_o <= '0';
          reg_cr_mpt_wr_o <= '0';
          reg_ch1fppcr_load_o <= '0';
          reg_ch2fppcr_load_o <= '0';
          reg_ch3fppcr_load_o <= '0';
          reg_ch4fppcr_load_o <= '0';
          reg_ch5fppcr_load_o <= '0';
          reg_ch6fppcr_load_o <= '0';
          reg_ch1rppcr_load_o <= '0';
          reg_ch2rppcr_load_o <= '0';
          reg_ch3rppcr_load_o <= '0';
          reg_ch4rppcr_load_o <= '0';
          reg_ch5rppcr_load_o <= '0';
          reg_ch6rppcr_load_o <= '0';
          reg_tvlr_load_o <= '0';
          reg_tvhr_load_o <= '0';
          reg_tb_rd_req_p_o <= '0';
          reg_tbcsr_clr_load_o <= '0';
          ack_in_progress <= '0';
        else
          reg_err_i2c_wdto_load_o <= '0';
          reg_err_i2c_err_load_o <= '0';
          reg_err_flim_pmisse_load_o <= '0';
          reg_err_fwdg_pmisse_load_o <= '0';
          reg_cr_rst_unlock_load_o <= '0';
          reg_cr_rst_load_o <= '0';
          reg_cr_mpt_wr_o <= '0';
          reg_ch1fppcr_load_o <= '0';
          reg_ch2fppcr_load_o <= '0';
          reg_ch3fppcr_load_o <= '0';
          reg_ch4fppcr_load_o <= '0';
          reg_ch5fppcr_load_o <= '0';
          reg_ch6fppcr_load_o <= '0';
          reg_ch1rppcr_load_o <= '0';
          reg_ch2rppcr_load_o <= '0';
          reg_ch3rppcr_load_o <= '0';
          reg_ch4rppcr_load_o <= '0';
          reg_ch5rppcr_load_o <= '0';
          reg_ch6rppcr_load_o <= '0';
          reg_tvlr_load_o <= '0';
          reg_tvhr_load_o <= '0';
          reg_tbcsr_clr_load_o <= '0';
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(5 downto 0) is
          when "000000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_bidr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_sr_gwvers_i;
            rddata_reg(15 downto 8) <= reg_sr_switches_i;
            rddata_reg(21 downto 16) <= reg_sr_rtm_i;
            rddata_reg(27 downto 22) <= reg_sr_hwvers_i;
            rddata_reg(28) <= reg_sr_wrpres_i;
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000010" => 
            if (wb_we_i = '1') then
              reg_err_i2c_wdto_load_o <= '1';
              reg_err_i2c_err_load_o <= '1';
              reg_err_flim_pmisse_load_o <= '1';
              reg_err_fwdg_pmisse_load_o <= '1';
            end if;
            rddata_reg(0) <= reg_err_i2c_wdto_i;
            rddata_reg(1) <= reg_err_i2c_err_i;
            rddata_reg(7 downto 2) <= reg_err_flim_pmisse_i;
            rddata_reg(13 downto 8) <= reg_err_fwdg_pmisse_i;
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000011" => 
            if (wb_we_i = '1') then
              reg_cr_rst_unlock_load_o <= '1';
              reg_cr_rst_load_o <= '1';
              reg_cr_mpt_wr_o <= '1';
            end if;
            rddata_reg(0) <= reg_cr_rst_unlock_i;
            rddata_reg(1) <= reg_cr_rst_i;
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000100" => 
            if (wb_we_i = '1') then
              reg_ch1fppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch1fppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000101" => 
            if (wb_we_i = '1') then
              reg_ch2fppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch2fppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000110" => 
            if (wb_we_i = '1') then
              reg_ch3fppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch3fppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000111" => 
            if (wb_we_i = '1') then
              reg_ch4fppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch4fppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001000" => 
            if (wb_we_i = '1') then
              reg_ch5fppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch5fppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001001" => 
            if (wb_we_i = '1') then
              reg_ch6fppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch6fppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001010" => 
            if (wb_we_i = '1') then
              reg_ch1rppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch1rppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001011" => 
            if (wb_we_i = '1') then
              reg_ch2rppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch2rppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001100" => 
            if (wb_we_i = '1') then
              reg_ch3rppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch3rppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001101" => 
            if (wb_we_i = '1') then
              reg_ch4rppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch4rppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001110" => 
            if (wb_we_i = '1') then
              reg_ch5rppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch5rppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001111" => 
            if (wb_we_i = '1') then
              reg_ch6rppcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch6rppcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010000" => 
            if (wb_we_i = '1') then
              reg_tvlr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_tvlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010001" => 
            if (wb_we_i = '1') then
              reg_tvhr_load_o <= '1';
            end if;
            rddata_reg(7 downto 0) <= reg_tvhr_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(5 downto 0) <= reg_tbmr_chan_i;
            reg_tb_rd_req_p_o <= '1';
            rddata_reg(31) <= reg_tbmr_wrtag_i;
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= reg_tbcyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_tbtlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_tbthr_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010110" => 
            if (wb_we_i = '1') then
              reg_tbcsr_clr_load_o <= '1';
            end if;
            rddata_reg(6 downto 0) <= reg_tbcsr_usedw_i;
            rddata_reg(16) <= reg_tbcsr_full_i;
            rddata_reg(17) <= reg_tbcsr_empty_i;
            rddata_reg(18) <= reg_tbcsr_clr_i;
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= reg_ch1ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_ch1ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_ch1ltsthr_tai_i;
            rddata_reg(31) <= reg_ch1ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= reg_ch2ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_ch2ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_ch2ltsthr_tai_i;
            rddata_reg(31) <= reg_ch2ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= reg_ch3ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_ch3ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_ch3ltsthr_tai_i;
            rddata_reg(31) <= reg_ch3ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= reg_ch4ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_ch4ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_ch4ltsthr_tai_i;
            rddata_reg(31) <= reg_ch4ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= reg_ch5ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_ch5ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_ch5ltsthr_tai_i;
            rddata_reg(31) <= reg_ch5ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= reg_ch6ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_ch6ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_ch6ltsthr_tai_i;
            rddata_reg(31) <= reg_ch6ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(5 downto 0) <= reg_lsr_front_i;
            rddata_reg(9 downto 6) <= reg_lsr_frontinv_i;
            rddata_reg(15 downto 10) <= reg_lsr_rear_i;
            rddata_reg(21 downto 16) <= reg_lsr_frontfs_i;
            rddata_reg(25 downto 22) <= reg_lsr_frontinvfs_i;
            rddata_reg(31 downto 26) <= reg_lsr_rearfs_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_oswr_switches_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_uidlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_uidhr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(15 downto 0) <= reg_tempr_i;
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- ID register bits
-- Gateware version
-- Status of on-board general-purpose switches
-- RTM detection lines cite{rtm-det}
-- Hardware version
-- White Rabbit present
-- I2C communication watchdog timeout error
  reg_err_i2c_wdto_o <= wrdata_reg(0);
-- I2C communication error
  reg_err_i2c_err_o <= wrdata_reg(1);
-- Frequency error
  reg_err_flim_pmisse_o <= wrdata_reg(7 downto 2);
-- Frequency watchdog error
  reg_err_fwdg_pmisse_o <= wrdata_reg(13 downto 8);
-- Reset unlock bit
  reg_cr_rst_unlock_o <= wrdata_reg(0);
-- Reset bit - active only if RST_UNLOCK is 1
  reg_cr_rst_o <= wrdata_reg(1);
-- Manual Pulse Trigger
-- pass-through field: Manual Pulse Trigger in register: CR
  reg_cr_mpt_o <= wrdata_reg(9 downto 2);
-- Value of front panel pulse counter
  reg_ch1fppcr_o <= wrdata_reg(31 downto 0);
-- Value of front panel pulse counter
  reg_ch2fppcr_o <= wrdata_reg(31 downto 0);
-- Value of front panel pulse counter
  reg_ch3fppcr_o <= wrdata_reg(31 downto 0);
-- Value of front panel pulse counter
  reg_ch4fppcr_o <= wrdata_reg(31 downto 0);
-- Value of front panel pulse counter
  reg_ch5fppcr_o <= wrdata_reg(31 downto 0);
-- Value of front panel pulse counter
  reg_ch6fppcr_o <= wrdata_reg(31 downto 0);
-- Rear panel pulse counter value
  reg_ch1rppcr_o <= wrdata_reg(31 downto 0);
-- Rear panel pulse counter value
  reg_ch2rppcr_o <= wrdata_reg(31 downto 0);
-- Rear panel pulse counter value
  reg_ch3rppcr_o <= wrdata_reg(31 downto 0);
-- Rear panel pulse counter value
  reg_ch4rppcr_o <= wrdata_reg(31 downto 0);
-- Rear panel pulse counter value
  reg_ch5rppcr_o <= wrdata_reg(31 downto 0);
-- Rear panel pulse counter value
  reg_ch6rppcr_o <= wrdata_reg(31 downto 0);
-- TAI seconds counter bits 31..0
  reg_tvlr_o <= wrdata_reg(31 downto 0);
-- TAI seconds counter bits 39..32
  reg_tvhr_o <= wrdata_reg(7 downto 0);
-- Channel mask
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- Buffer counter
-- Buffer full
-- Buffer empty
-- Clear tag buffer
  reg_tbcsr_clr_o <= wrdata_reg(18);
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Front panel channel input state
-- Front panel INV-TTL input state
-- Rear panel input state
-- Front panel input failsafe state
-- Front panel inverter input failsafe state
-- Rear panel input failsafe state
-- Switch state
-- LS bits of 1-wire DS18B20U thermometer ID
-- MS bits of 1-wire DS18B20U thermometer ID
-- TEMP
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
